<template>
<div>
    <div class="voitures-page">
            <page-header title="Entreprises">
                            <div slot="nav">
                <div v-if="authorize('exporte-vehicule')" class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a :href="excelUrl"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                          <a href="javascript:;" class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-pdf t-plus-1 text-danger fa-fw fa-lg "></i> PDF</a>
                    </div>
                    </div>
              </div>
            </page-header>
              
            <div class="col-md-12" >
              <div :class="['card bg-transparent content-card ']" >
               <div :class="['card-header content-card-title pl-0']">
                    <h3 class="card-title pl-0">
                        <router-link v-if="authorize('ajoute-vehicule')" to="/voitures/ajout"  class="ml-4 btn btn-xs btn-secondary text-xs">
                         <i class="fas fa-plus-circle right"></i>  Nouvelle voiture
                        </router-link>
                    </h3>

                 <div class="card-tools">
                  <filter-bar ref="filterBar" @filter-set="search"></filter-bar>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body content-card-body pl-4 pr-4 " v-show="!NoDataForSearch && !NoDataAtAll">
                    <div class="row d-flex align-items-stretch card-car-parent   ">
                         <vehicule-item @location-event="louer" @suppression-event="remove" :entity="entity" v-for="entity in filteredCars" :key="entity.id"></vehicule-item>
                    </div>
              </div>
              <!-- /.card-body -->
               </div>
               <!-- /.card -->

          
            </div>
            <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
        
          
    </div>
    <mettre-en-location :visible="showModal"></mettre-en-location>
</div>
</template>

<script>


   import Master from "./../Master.vue";
   import MettreEnLocation from "./../../components/MettreEnLocation.vue";
   import VehiculeItem from "./../../components/VehiculeItem.vue";
    export default {
        mixins: [Master],
        data()
          {
            return{ 
                roles:[],
                isLoading:false,
                init:true,
                showModal:false,
                entities:[],
                options :
                {
                   marques: []
                },
                moreParams:{filter:""},
                modeEdit:false


              
              }
        }
        ,
        mounted() 
        {
            this.$events.$on('filter-set',(e) => (this.search(e)))
            this.$events.$on('newCardAdded',(e) => {
                  this.entities.unshift(e)
            })

            if(this.flashMessage.active)
            {
              flash(this.flashMessage.message)
            }
        },
        created(){
           this.fetchOptions()
           this.fetch()
           this.modeEdit = true
           
        },
        computed:
        {

           excelUrl()
           {
             return '/voitures/export?format=excel&q='+this.searchTxt
           },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.filteredCars  == 0  && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },

            hasData()
            {

              return (this.entities.length>0) ? true : false
            
            },
            filteredCars()
            { 
                                    
                var filtered = []
                if(this.moreParams.filter !="")
                {
                    this.isLoading = true 
                      filtered =   this.entities.filter((entity) =>
                    {
                        return entity.marque.libelle.toLowerCase().match(this.moreParams.filter) || 
                               entity.modele.libelle.toLowerCase().match(this.moreParams.filter) ||
                               entity.type_motorisation.libelle.toLowerCase().match(this.moreParams.filter) ||
                               entity.type_vehicule.libelle.toLowerCase().match(this.moreParams.filter) ||
                               entity.boite_vitesse.toLowerCase().match(this.moreParams.filter) ||
                               entity.couleur.toLowerCase().match(this.moreParams.filter) ||
                               entity.plaque_immatriculation.toLowerCase().match(this.moreParams.filter) ||
                               entity.date_mise_en_circulation.toLowerCase().match(this.moreParams.filter) ||
                               entity.libelle.toLowerCase().match(this.moreParams.filter)
                    })
                }

                else
                {
                    filtered = this.entities

                }

                this.isLoading = false
                                 $('.card-car-parent').unblock()

                return filtered
            }
        },
        methods:
        {
             fetch(page)
             {
                var url = "api/vehicules"
                window.event.$emit("isLoading",true)

        
                axios.get(url).then((response) => 
                { 

                       this.entities = response.data

                       window.event.$emit("isLoading",false)
                       if(this.init==true)
                        {
                          this.init =false
                        }
                        if(this.pageInit==false)
                        {
                            this.pageInit =true
                        }
                        window.scrollTo(0,0)
                       
                },
                (error) => {
                         console.log("Promise Rejected:")

                });
             },
             fetchOptions()
             {
               axios.get("api/dispatcher/options/vehicules").then((response) => 
                { 
                      this.options.marques = response.data.marques.filter( e => {

                       return  e.modeles.length>0
                      })
                      this.options.motorisations = response.data.motorisations
                      this.options.tpermis = response.data.tpermis
                      this.options.tvehicules = response.data.tvehicules

                      response.data.voptions.forEach( e => 
                      {
                        
                        if(e.code == "SEC")
                          this.options.optSecurite = e.options
                        if(e.code == "CNF")
                         this.options.optConfort = e.options
                        if(e.code == "PLS")
                         this.options.optPlaisir = e.options
                      }  )

                      //envoie un event pour signifier le chargement des options
                      this.$root.$emit('initOption');
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
             callModal()
             {
                 
                 this.$refs.newCar.showModalOnCreate()
             },

              onSubmit(e)
             {
                    this.isLoading = true
                    if(this.modeEdit==false)
                    {
                      this.form.post("api/roles").then((value) => 
                      { 
                          
                        this.form.reset();
                        this.fetch()
                        flash("<span>Enregistré <strong>avec succès</strong></span>",'primary')
                        this.isLoading = false
                        this.$refs['inputModal'].hide()

                      },
                      (error) =>
                      {
                        this.isLoading = false
                      });
                    }
                    else
                    {
                      this.form.patch("api/roles/"+this.form.id).then((response) => 
                      { 
                          
                         
                        var ent = this.entities.find(element => element.id == this.form.id);
                        var index = this.entities.indexOf(ent)
                        this.entities[index] = response.entity

                        this.form.reset();
                        flash("<span>Modifié <strong>avec succès</strong></span>",'primary')
                        this.isLoading = false
                        this.$refs['inputModal'].hide()


                      },
                      (error) =>
                      {
                        this.isLoading = false
                      });
                    }

             },
             remove(e)
             {
                    this.isLoading = true
                    alertConfirm("Cette action est <b>irréversible</b>, souhaitez-vous vraiment <b>supprimer</b> cette voiture de manière définitive ?","Suppréssion d'une Voiture")
                    .then(result => {
                        if(result)
                        {
                           axios.delete("api/vehicules/"+e.id).then((response) => 
                            { 


                              this.entities.splice(this.entities.indexOf(e),1)

                              flash("<span>Supprimé <strong>avec succès</strong></span>")
                              this.isLoading = false

                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });

                

             },
             search(q)
             {

                $('.card-car-parent').block({ 
                    message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                    css: { border: 'none' },
                                            
                        // styles for the overlay 
                        overlayCSS:  { 
                            backgroundColor: '#000', 
                            opacity:         0.06, 
                            cursor:          'wait' 
                        },
                });  
                this.moreParams.filter = q.toLowerCase()
             },
             //Met un vehicule en location
             louer(entity)
             {
               this.showModal = true;
               window.event.$emit('mettre-en-location-event',entity)
             }
             
        },
        watch:
        {
          isLoading(value)
          {
         
              
          }
        },
        components:
        {
          MettreEnLocation,VehiculeItem

        }
    }
</script>
<style lang="scss">

.car-card .tarif {
  font-weight: 700;
  color: #e60000;
  font-size: 26px;
    font-weight: bold;
}
.car-card .tarif span.details {
  font-size: 18Px;
  font-weight: lighter;
}


.car-card .card-body {
  
  height: 200px;
}
.car-card .media-link img {
  
  height: 200px;
}
.car-card .info li div i  {
   font-size: 1.65rem;
       line-height: 1.6;
}


    .car-card .title {
      font-size: 15px;
      font-weight: 700;
    }

    .car-card .media-link {
      padding: 0;
      display: block;
      position: relative;
      overflow: hidden;
      text-align: center;
  }

  .car-card  .media-link .icon-view {
    position: absolute;
    top: 50%;
    left: 50%;
    margin-left: -40px;
    margin-top: -40px;
    opacity: 0;
    -webkit-animation: fadeOut .4s;
    animation: fadeOut .4s;
}
.car-card .card-header{
        border-bottom: 1px solid rgba(0, 0, 0, 0.04);

}
.car-card .icon-view {
  width: 80px;
  height: 80px;
  padding: 5px;
  border: solid 1px rgba(0, 0, 0, 0.6);
  border-radius: 50%;
  display: inline-block;
}
.car-card  .icon-view strong {
  display: block;
  width: 68px;
  height: 68px;
  border-radius: 50%;
  text-align: center;
  background-color: rgba(0, 0, 0, 0.6);
  color: #ffffff;
}
.car-card .info li {
  height: 30px;
  line-height: 20px;
  font-size: 10px;
  font-weight: bold;
  text-align: center;
  width: 100%;
  padding: 3px 0 3px 0;
}
.car-card .info {
  display: -webkit-flex;
  -webkit-justify-content: space-between;
  display: flex;
  justify-content: space-between;
  white-space: nowrap;
}

.clearfix {
  zoom: 1;
}
.car-card .info li:first-child div {
  border-left: none;
}

.car-card .info li div {
  padding: 0 9px;
  border-left: 1px solid #ffd200;
  margin-top: 5px;
  color: #6c757d;
}
.clearfix:after {
  content: ".";
  display: block;
  height: 0;
  clear: both;
  visibility: hidden;
}
.car-card .block-info {
  background: #f2f2f2;
  width: 100%;
}
.car-card .block-info ul {
    list-style: none;
}
.car-card .info li {
  height: 30px;
  line-height: 20px;
  font-size: 10px;
  font-weight: bold;
  text-align: center;
  width: 100%;
  padding: 3px 0 3px 0;
}
.card-car .image-block {
    border: none;
    padding-right: 0px;
    background-color: white;
}
.car-card .card-car-body
{
   min-height: 200px;
}
.car-card .block-data
{
      padding-bottom: 0px !important;
    padding-top: 0px !important;
}
/* 
  ##Device = Desktops
  ##Screen = 1281px to higher resolution desktops
*/

@media (min-width: 1281px) {
  
  //CSS
  
}

/* 
  ##Device = Laptops, Desktops
  ##Screen = B/w 1025px to 1280px
*/

@media (min-width: 1025px) and (max-width: 1280px) {
  
  //CSS
  
}

/* 
  ##Device = Tablets, Ipads (portrait)
  ##Screen = B/w 768px to 1024px
*/

@media (min-width: 768px) and (max-width: 1024px) {
  
  //CSS
  
}

/* 
  ##Device = Tablets, Ipads (landscape)
  ##Screen = B/w 768px to 1024px
*/

@media (min-width: 768px) and (max-width: 1024px) and (orientation: landscape) {
  
  //CSS
  
}

/* 
  ##Device = Low Resolution Tablets, Mobiles (Landscape)
  ##Screen = B/w 481px to 767px
*/

@media (min-width: 481px) and (max-width: 767px) {
  
  //CSS
  
}

/* 
  ##Device = Most of the Smartphones Mobiles (Portrait)
  ##Screen = B/w 320px to 479px
*/

@media (min-width: 320px) and (max-width: 480px) {
  .content-card .content-card-title .card-title a
  {
    margin-left: 0px !important;
  }

  .car-card .card-body
   {
    height: auto;
   }
   .car-card .block-details
   {
     padding-top: 0px !important;
   } 
    .car-card .card-body .card-car-body
   {
     flex-direction: column;
    -ms-flex-direction: column;
   }
.card-car .image-block {
    border: none;
    min-height: 223px;
    padding-right: 0px !important;
}
   .car-card .media-link img {
    height: auto;
    width: 100%; 
}
.car-card .block-info {
    background: #f2f2f2;
     position: relative; 
    width: 100%;
    right: 0px;
    bottom: 0px;
}
.car-card .block-data {
    padding-bottom: 0px !important;
    padding-top: 0px !important;
}
.car-card .block-info ul {
    list-style: none;
    margin-bottom: 0px;
}

.car-card .card-footer {

        border-top: 1px solid rgba(0, 0, 0, 0.04);
}
.car-card .info li div {
    padding: 0 0px;
    border-left: none;
    margin-top: 0px;
        display: -webkit-box !important;
    display: flex !important;
    -webkit-box-pack: center !important;
    justify-content: center !important;
}
.car-card .info li div span  {
      font-size: 0.9rem;
    margin-left: 5px;
    line-height: 2.4;
}
.car-card .info li div i  {
   font-size: 1.4rem;
       line-height: 1.6;
}
.car-card .info li {
    line-height: 20px;
    font-size: 10px;
    font-weight: bold;
    text-align: center;
    width: 100%;
    padding: 0px !important;
        padding-left: 5px !important;
    padding-right: 5px !important;
    border-left: 1px solid #ffd200;
}
.car-card .info li:first-child {
    
    border-left: none;
}
.car-card .block-details p i {
   border-left: none;
 }


}
</style>